import java.awt.Container;
import java.awt.GridLayout;
import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;

import javax.swing.JList;
import javax.swing.JScrollPane;

public class EvaluationUI {
  
  Container c;
  Measurement[] measurements;
  Comparable[] unsortedData;
  
  public EvaluationUI(
      Measurement[] measurements, 
      Comparable[] unsortedData) {
    this.measurements = measurements;
    this.unsortedData = unsortedData;
  }
  
  public void show() {
    JFrame f = createFrame();
    c.add(createPanel(unsortedData, "Unsortiert"));
    addMeasurements();
    f.setSize(1000, 800);
    f.setVisible(true);
  }
  
  private JFrame createFrame() {
    JFrame f = new JFrame();
    f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    f.setTitle("Uebung 10 - Sortieren");    
    c = f.getContentPane();
    c.setLayout(new GridLayout(2, (int) Math.ceil(measurements.length/2), 0, 1));
    return f;
  }
  
  private void addMeasurements() {
    int rank = 0;
    for (Measurement m: measurements) {
      c.add(createPanel(
        m.sortedData, 
        String.format("%d. %s-%dms", 
          ++rank,
          m.sorter.getClass().getName(), 
          m.timer.getTime())));
    }
  }
  
  private JComponent createPanel(Comparable[] data, String label) {
    JPanel p = new JPanel();
    BorderLayout bl = new BorderLayout();
    p.setLayout(bl);
    p.add(new JLabel(label), BorderLayout.NORTH);
    JList text = new JList(data);
    JScrollPane scroll = new JScrollPane(text);
    p.add(scroll, BorderLayout.CENTER);
    return p;
  }
}