package at.jku.students;

import at.jku.ssw.Sorter;

/** A heap-based sorting algorithm to create a sorted array. */
public class HeapSort extends Sorter {

  /** Sorts the array <code>items</code> of comparable objects. */
  public void sort(Comparable[] data) {
    int n = data.length;
    for (int i = n/2; i > 0; i--) {
      downHeap(data, i, n);
    }
    do {
      swap(data, 1, n);
      n--;
      downHeap(data, 1, n);
    } while (n > 1);
  } 
  
  private static void downHeap(Comparable[] data, int pos, int length) {
    while(true) {
      int son = 2 * pos;
      if (son > length) {
        break;
      }
      if (son < length && data[son-1].compareTo(data[son]) < 0) {
        son++;
      }
      if (data[pos-1].compareTo(data[son-1]) >= 0) {
        break;
      }
      swap(data, pos, son);
      pos = son;
    }
  }
  
  private static void swap(Comparable[] data, int index1, int index2) {
    Comparable help = data[index1-1];
    data[index1-1] = data[index2-1];
    data[index2-1] = help;
  }
  
}